import { ElementRef, AfterContentInit, Renderer2 } from '@angular/core';
export declare type uiButtonType = 'primary';
export declare type uiButtonShape = 'circle' | null;
export declare type uiButtonSize = 'sm' | 'lg';
export declare type uiButtonOutlineType = 'primary';
export declare class ButtonComponent implements AfterContentInit {
    private _elementRef;
    private _renderer;
    _el: HTMLElement;
    nativeElement: HTMLElement;
    _iconElement: HTMLElement;
    _type: uiButtonType;
    _shape: uiButtonShape;
    _size: uiButtonSize;
    _classList: Array<string>;
    _iconOnly: boolean;
    _loading: boolean;
    _clicked: boolean;
    _ghost: uiButtonOutlineType;
    _prefixCls: string;
    uiOutlineType: uiButtonOutlineType;
    uiType: uiButtonType;
    uiShape: uiButtonShape;
    uiSize: uiButtonSize;
    uiLoading: boolean;
    /** toggle button clicked animation */
    _onClick(): void;
    _setIconDisplay(value: boolean): void;
    /** temp solution since no method add classMap to host https://github.com/angular/angular/issues/7289 */
    _setClassMap(): void;
    constructor(_elementRef: ElementRef, _renderer: Renderer2);
    ngAfterContentInit(): void;
    readonly _innerIElement: HTMLElement;
}
