import { EventEmitter, ViewContainerRef, TemplateRef, OnInit, OnChanges, OnDestroy, AfterContentInit, QueryList, SimpleChanges, EmbeddedViewRef } from '@angular/core';
export declare class HeaderComponent {
}
export declare class FooterComponent {
}
export declare class TemplateDirective {
    template: TemplateRef<any>;
    type: string;
    name: string;
    constructor(template: TemplateRef<any>);
    getType(): string;
}
export declare class TemplateWrapperDirective implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    item: any;
    index: number;
    templateRef: TemplateRef<any>;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class ColumnComponent implements AfterContentInit {
    field: string;
    colId: string;
    sortField: string;
    filterField: string;
    header: string;
    footer: string;
    sortable: any;
    editable: boolean;
    filter: boolean;
    filterMatchMode: string;
    filterType: 'text';
    rowspan: number;
    colspan: number;
    style: any;
    styleClass: string;
    hidden: boolean;
    expander: boolean;
    selectionMode: string;
    filterPlaceholder: string;
    filterMaxlength: number;
    frozen: boolean;
    sortFunction: EventEmitter<any>;
    templates: QueryList<any>;
    template: TemplateRef<any>;
    headerTemplate: TemplateRef<any>;
    bodyTemplate: TemplateRef<any>;
    footerTemplate: TemplateRef<any>;
    filterTemplate: TemplateRef<any>;
    editorTemplate: TemplateRef<any>;
    ngAfterContentInit(): void;
}
export declare class RowComponent {
    columns: QueryList<ColumnComponent>;
}
export declare class HeaderColumnGroupComponent {
    rows: QueryList<any>;
}
export declare class FooterColumnGroupComponent {
    rows: QueryList<any>;
}
export declare class ColumnBodyTemplateLoaderComponent implements OnInit, OnChanges, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    rowData: any;
    rowIndex: number;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
}
export declare class ColumnHeaderTemplateLoaderComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class ColumnFooterTemplateLoaderComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class ColumnFilterTemplateLoaderComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class ColumnEditorTemplateLoaderComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: any;
    rowData: any;
    rowIndex: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class TemplateLoaderComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    template: TemplateRef<any>;
    data: any;
    view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class SharedModule {
}
