import { OnInit, ElementRef, OnChanges, Renderer2, SimpleChange } from '@angular/core';
import { RowComponent } from './row.component';
export declare abstract class EmbeddedProperty {
    span: number;
    pull: number;
    push: number;
    offset: number;
    order: number;
}
export declare class ColComponent implements OnInit, OnChanges {
    private _elementRef;
    _uiRow: RowComponent;
    private _renderer;
    _classList: Array<string>;
    _el: HTMLElement;
    _prefixCls: string;
    _prefix: string;
    readonly paddingLeft: number;
    readonly paddingRight: number;
    uiSpan: number;
    uiOrder: number;
    uiOffset: number;
    uiPush: number;
    uiPull: number;
    uiXs: number | EmbeddedProperty;
    uiSm: number | EmbeddedProperty;
    uiMd: number | EmbeddedProperty;
    uiLg: number | EmbeddedProperty;
    uiXl: number | EmbeddedProperty;
    [name: string]: any;
    /** temp solution since no method add classMap to host https://github.com/angular/angular/issues/7289*/
    setClassMap(): void;
    generateClass(): any[];
    ngOnChanges(changes: {
        [propertyName: string]: SimpleChange;
    }): void;
    constructor(_elementRef: ElementRef, _uiRow: RowComponent, _renderer: Renderer2);
    ngOnInit(): any;
}
