import { OnInit, AfterContentInit, AfterContentChecked, EventEmitter, ElementRef, Renderer2 } from '@angular/core';
import { OptionComponent } from './option.component';
import { ControlValueAccessor } from '@angular/forms';
export declare class SelectComponent implements OnInit, AfterContentInit, AfterContentChecked, ControlValueAccessor {
    private _elementRef;
    private _renderer;
    _el: HTMLElement;
    _prefixCls: string;
    _classList: Array<string>;
    _dropDownClassMap: any;
    _dropDownPrefixCls: string;
    _selectionClassMap: any;
    _selectionPrefixCls: string;
    _size: string;
    _value: Array<string> | string;
    _placeholder: string;
    _notFoundContent: string;
    _isOpen: boolean;
    _disabled: boolean;
    _showSearch: boolean;
    _isTags: boolean;
    _searchText: string;
    _triggerWidth: number;
    _selectedOption: OptionComponent;
    _operatingMultipleOption: OptionComponent;
    _selectedOptions: Set<OptionComponent>;
    _options: Array<OptionComponent>;
    _cacheOptions: Array<OptionComponent>;
    _filterOptions: Array<OptionComponent>;
    _tagsOptions: Array<OptionComponent>;
    _activeFilterOption: OptionComponent;
    _isMultiInit: boolean;
    _dropDownPosition: 'top' | 'bottom';
    _isMultiple: boolean;
    _composing: boolean;
    _mode: any;
    _keepUnListOptions: boolean;
    _allowClear: boolean;
    onChange: any;
    onTouched: any;
    searchInputElementRef: ElementRef;
    trigger: ElementRef;
    dropdownUl: ElementRef;
    uiSearchChange: EventEmitter<any>;
    uiOpenChange: EventEmitter<any>;
    uiScrollToBottom: EventEmitter<boolean>;
    uiFilter: boolean;
    uiMaxMultiple: number;
    uiAllowClear: boolean | string;
    uiKeepUnListOptions: boolean | string;
    uiMode: any;
    uiMultiple: boolean;
    uiPlaceHolder: string;
    uiNotFoundContent: string;
    uiSize: string;
    uiShowSearch: boolean;
    uiTags: boolean;
    uiDisabled: boolean;
    uiOpen: boolean;
    /** new ui-option insert or new tags insert */
    addOption: (option: any) => void;
    /** ui-option remove or tags remove */
    removeOption(option: any): void;
    /** dropdown position changed */
    onPositionChange(position: any): void;
    compositionStart(): void;
    compositionEnd(): void;
    /** clear single selected option */
    clearSelect($event?: any): void;
    /** click dropdown option by user */
    clickOption(option: any, $event?: any): void;
    /** choose option */
    chooseOption(option: any, isUserClick?: boolean, $event?: any): void;
    updateWidth(element: any, text: any): void;
    dropDownScroll(ul: HTMLUListElement): void;
    checkDropDownScroll(): void;
    /** determine if option in set */
    isInSet(set: any, option: any): OptionComponent;
    /** cancel select multiple option */
    unSelectMultipleOption: (option: any, $event?: any, emitChange?: boolean) => void;
    /** select multiple option */
    selectMultipleOption(option: any, $event?: any): void;
    /** emit multiple options */
    emitMultipleOptions(): void;
    /** update selected option when add remove option etc */
    updateSelectedOption(currentModelValue: any, triggerByNgModel?: boolean): void;
    forceUpdateSelectedOption(value: any): void;
    uiValue: string | Array<string>;
    clearAllSelectedOption(emitChange?: boolean): void;
    handleKeyEnterEvent(event: any): void;
    handleKeyBackspaceEvent(event: any): void;
    handleKeyDownEvent($event: MouseEvent): void;
    handleKeyUpEvent($event: MouseEvent): void;
    preOption(option: any, options: any): any;
    nextOption(option: any, options: any): any;
    clearSearchText(): void;
    updateFilterOption(updateActiveFilter?: boolean): void;
    onSearchChange(searchValue: any): void;
    onClick(e: any): void;
    onKeyDown(e: any): void;
    closeDropDown(): void;
    setClassMap(): void;
    setDropDownClassMap(): void;
    scrollToActive(): void;
    flushComponentState(): void;
    _setTriggerWidth(): void;
    _getTriggerRect(): ClientRect;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    constructor(_elementRef: ElementRef, _renderer: Renderer2);
    ngAfterContentInit(): void;
    ngOnInit(): void;
    ngAfterContentChecked(): void;
    private _updateValue(value, emitChange?);
}
