/** code from https://github.com/angular/material2 */
import { AfterContentChecked, AfterViewInit, ElementRef, EventEmitter, OnInit, Renderer2, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { TabComponent } from './tab.component';
import { TabsNavComponent } from './tabs-nav.component';
export interface AnimatedInterface {
    inkBar: boolean;
    tabPane: boolean;
}
export declare class TabChangeEvent {
    index: number;
    tab: TabComponent;
}
export declare type uiTabPosition = 'top' | 'bottom' | 'left' | 'right';
export declare type uiTabPositionMode = 'horizontal' | 'vertical';
export declare type uiTabType = 'line' | 'card';
export declare class TabSetComponent implements AfterContentChecked, OnInit, AfterViewInit {
    private _renderer;
    _el: any;
    _classMap: any;
    _prefixCls: string;
    _width: any;
    _tabPosition: uiTabPosition;
    _tabPositionMode: uiTabPositionMode;
    _indexToSelect: number | null;
    _selectedIndex: number | null;
    _isViewInit: boolean;
    _tabs: TabComponent[];
    uiTabBarExtraTemplate: TemplateRef<void>;
    uiTabBarExtraContent: TemplateRef<void>;
    _tabNav: TabsNavComponent;
    _tabContent: ElementRef;
    _hostContent: ElementRef;
    uiAnimated: AnimatedInterface | boolean;
    uiShowPagination: boolean;
    uiHide: boolean;
    uiSelectedIndex: number | null;
    readonly uiSelectedIndexChange: Observable<number>;
    uiSelectChange: EventEmitter<TabChangeEvent>;
    uiSize: string;
    _type: uiTabType;
    tabs: TabComponent[];
    uiTabPosition: uiTabPosition;
    uiType: uiTabType;
    _setPosition(value: uiTabPosition): void;
    _setClassMap(): void;
    clickLabel(index: number): void;
    ngOnInit(): void;
    ngAfterContentChecked(): void;
    ngAfterViewInit(): void;
    private _createChangeEvent(index);
    readonly inkBarAnimated: boolean;
    readonly tabPaneAnimated: boolean;
    constructor(_renderer: Renderer2);
}
