import { AfterViewInit, OnDestroy, AfterViewChecked, ElementRef, NgZone } from '@angular/core';
import { Subscription } from 'rxjs/Subscription';
import { ColumnComponent } from '../common/shared';
import { DomHandler } from '../dom/domhandler';
import { TableComponent } from './table.component';
export declare class ScrollableViewComponent implements AfterViewInit, OnDestroy, AfterViewChecked {
    dt: TableComponent;
    el: ElementRef;
    domHandler: DomHandler;
    zone: NgZone;
    columns: ColumnComponent;
    frozen: boolean;
    scrollHeaderViewChild: ElementRef;
    scrollHeaderBoxViewChild: ElementRef;
    scrollBodyViewChild: ElementRef;
    scrollTableViewChild: ElementRef;
    scrollFooterViewChild: ElementRef;
    scrollFooterBoxViewChild: ElementRef;
    virtualScrollerViewChild: ElementRef;
    headerScrollListener: Function;
    bodyScrollListener: Function;
    footerScrollListener: Function;
    frozenSiblingBody: Element;
    _scrollHeight: string;
    subscription: Subscription;
    totalRecordsSubscription: Subscription;
    initialized: boolean;
    constructor(dt: TableComponent, el: ElementRef, domHandler: DomHandler, zone: NgZone);
    scrollHeight: string;
    ngAfterViewChecked(): void;
    ngAfterViewInit(): void;
    bindEvents(): void;
    unbindEvents(): void;
    onHeaderScroll(event: any): void;
    onFooterScroll(event: any): void;
    onBodyScroll(event: any): void;
    setScrollHeight(): void;
    setVirtualScrollerHeight(): void;
    hasVerticalOverflow(): boolean;
    alignScrollBar(): void;
    ngOnDestroy(): void;
}
